<?php 

function get($table_name, $filter, $deleted_at=false) {
	$CI =& get_instance();
	if($filter) {
		apply_filter($filter);
	}
	if($deleted_at) {
		$CI->db->where('deleted_at', null);
	}
	$rs=$CI->db->get($table_name);
	return $rs->result_array();
}

function add($table_name, $data, $date=true) {
	$CI =& get_instance();
	if(!empty($date)) {
		$user_id=$CI->session->userdata('user_id');
		$data['created_at']=date('Y-m-d H:i:s');
		$data['created_by']=$user_id;
	}

	$CI->db->insert($table_name, $data);
	return $CI->db->insert_id();
}

function update($table_name, $data, $table_id, $edit_id, $date=true) {
	$CI =& get_instance();
	if(!empty($date)) {
		$user_id=$CI->session->userdata('user_id');
		$data['update_at']=date('Y-m-d H:i:s');
		$data['update_by']=$user_id;
	}

	$CI->db->where($table_id, $edit_id);
	return $CI->db->update($table_name,$data);
}

function delete($table_name, $filter, $date=true) {
	$CI =& get_instance();
	if($filter) {
		apply_filter($filter);
	}
	if(!empty($date)) {
		$user_id=$CI->session->userdata('user_id');
		$data['deleted_at']=date('Y-m-d H:i:s');
		$data['deleted_by']=$user_id;
	}
	return $CI->db->update($table_name, $data);
}

	/* 
		Message displayget_pagi		accept 2 parameter.
		1 - message text.
		2 - (optional) type of message success, error, warning. Bydefault error is selected.
	*/
		function set_message($message,$type="error") {

			/* Check empty */
			if(empty(trim($message))) {
				return false;
			}

			$CI =& get_instance();
			if($type=="error") {
				$add=$CI->session->userdata('error');
				$set_message=$add."<li>".$message."</li>";
				$CI->session->set_userdata('error',$set_message);
			}
			else if($type=="success") {
				$add=$CI->session->userdata('success');
				$set_message=$add."<li>".$message."</li>";
				$CI->session->set_userdata('success',$set_message);
			}
			else if($type=="warning") {
				$add=$CI->session->userdata('warning');
				$set_message=$add."<li>".$message."</li>";
				$CI->session->set_userdata('warning',$set_message);
			}  
		}	

	/* 
		print array in format 
		accept 1 parameter as array.
	*/

		function dsm($var) {
			if(is_array($var) || is_object($var)) {
				echo "<pre>".print_r($var,true)."</pre>";
			}
			else {
				echo "<pre>".$var."</pre>";
			}
			$debug=debug_backtrace();
			echo "<pre>".$debug[0]['file'].", line :".$debug[0]['line']."</pre><br/>";  
		}

		/* print last execulated query */
		function lq() {
			$CI =& get_instance();
			dsm($CI->db->last_query());
		}	

	/* 
		redirect back - redirect to request page.
	*/
		function redirect_back() {
			$url=base_url();
			if(isset($_SERVER['HTTP_REFERER'])) {
				$url=$_SERVER['HTTP_REFERER'];  
			}

		// handle back_to parameter
			if(isset($_GET['back_to']) && !empty($_GET['back_to'])) {
				$url = $_GET['back_to'];
			}

		// handle back_to parameter
			if(isset($_POST['back_to']) && !empty($_POST['back_to'])) {
				$url = $_POST['back_to'];
			}

			if(!filter_var($url,FILTER_VALIDATE_URL)) {
				$url = base_url().$url;
			}


			redirect($url);
		}	

		function login_check($redirect_back=1) {
			$CI=&get_instance();
			$CI->load->model('admin_login/login_model');
			$user_id=$CI->session->userdata('user_id');
			if(empty($user_id)) {

				/* Check remember me token exist */
				if($CI->login_model->check_remember()) {
					return true;
				}
				set_message("Your session has been expired, Please login again to continue.");
				redirect(base_url());
				/* Set back to page for authentication fail */
			/*$back_to='';
			$current_uri=$CI->uri->uri_string();
			if(!empty($current_uri)) {
				$back_to='?back_to='.$current_uri;
			}
			$message="Your session has been expired, Please login again to continue.";
			send_
			return redirect_action($redirect_back, base_url().$back_to,$message);*/
		}

			// disabled user logout
		$user_filter['user_id']=$user_id;
		$result_login=$CI->login_model->get_users($user_filter);
		/*print_last_query();
		dsm($result_login);die;*/
		if(!empty($result_login)) {
			$result_login=reset($result_login);
			if($result_login['enable']==0 || $result_login['deleted_at']!=NULL) {
				$CI->session->sess_destroy();
				if($result_login['role_title']=='Client' || $result_login['role_title']=='Manager') {
					$role=strtolower($result_login['role_title']);
					redirect(base_url().'login/'.$role);
				}
				else {
					redirect(base_url());
				}
				die;
			}
		}
		return true;
	}

	/* 
		$permission_machine to check in session 
			@type mixed array or integer
		$check_type
			@string
			AND - User must have all the permission from provided 
			OR - User must have any one permission from list
		$redirect_back
			@type Integer
			0 - Return true/ false 
			1 - Redirect to back page
			2 - echo html formatted error message and stop execution
			3 - Return json formatted error message and die

		@Return true on permission found and above action from 0,1,2 if permission not exist

	*/
		function permission_check($permission_machine, $redirect_back=1, $check_type='and') {
			login_check($redirect_back);
			$CI=&get_instance();
			$role_id=$CI->session->userdata('role_id');
			$role=$CI->session->userdata('role');
			$user_id=$CI->session->userdata('user_id');

			$user_permission=$CI->session->userdata('permission_machine');

			if(empty($user_permission)) {
				return redirect_action($redirect_back);
			}

			/* If user have system admin permission, Always return true */
			if(in_array('10', $user_permission)) {
				return true;
			}

			/* Check multiple permission */
			if(is_array($permission_machine)) {
			//dsm($permission_machine);die;
				$available_permission=false;
				$unavailable_permission=false;

				/* Checking permission */
				foreach ($permission_machine as $permission) {
					if(in_array($permission, $user_permission)) {
						$available_permission=true;
					}
					else {
						$unavailable_permission=true;
					}
				}

				/* when single permission required */
				if(strtolower($check_type) == 'or') {
					if($available_permission) {
						return true;	
					}
					else {
						redirect_action($redirect_back);
					}

				}
				/* When all permission required */
				else {
					if($available_permission && $unavailable_permission===false) {
						return true;
					}
					else {
						redirect_action($redirect_back);
					}
				}
			}
			/* Check single permission */
			else {
				if(in_array($permission_machine, $user_permission)) {
					return true;
				}
				else {
					redirect_action($redirect_back);
				}
			}
		}

		function redirect_action($redirect_back=1, $redirect_url=false, $error_msg="You don't have sufficient permission to access this resource.") {
			if($redirect_back==0) {
				return false;
			}
			elseif($redirect_back==1) {
				set_message($error_msg);
				if($redirect_url == false) {
					redirect_back();die;
				}
				else {
					redirect($redirect_url);
				}
			}
			elseif($redirect_back==2) {
				echo '<div class="alert alert-danger alert-dismissable">
				<button aria-hidden="true" data-dismiss="alert" class="close" type="button">x</button>
				'.$error_msg.'
				</div>';
				die;
			}
			elseif($redirect_back==3) {
				echo json_encode(array("status"=>0,'message'=>$error_msg));
				die;
			}
			else{
				return false;
			}
		}

		function combine() {
			$args=func_get_args();
			$return='';
			foreach($args as $arg) {
				$return.=$arg.' - ';
			}
			$return=rtrim($return,' - ');
			return $return;
		}	

	/* 
		Create textbox from array 
		accept 4 parameters
		1 - name of textbox control.
		2 - value to set in placeholder attribute.
		3 - value to set bydefault in value attribute.
		4 - HTML css attributes.
	*/
		function generate_textbox($name,$placeholder=false,$default=false,$other=false) {
			$output = "<input type=\"text\" name=\"{$name}\" value=\"{$default}\" placeholder=\"{$placeholder}\" ".$other.">";
			return $output;
		}

	/* 
		Create number textbox from array 
		accept 4 parameters
		1 - name of numeric textbox control.
		2 - value to set in placeholder attribute.
		3 - value to set bydefault in value attribute.
		4 - HTML css attributes.		
	*/
		function generate_numberbox($name,$placeholder=false,$default=false,$other=false) {
			$output = "<input type=\"number\" name=\"{$name}\" value=\"{$default}\" placeholder=\"{$placeholder}\" ".$other.">";
			return $output;
		}

	/* 
		Create file from array
		accept 2 parameters
		1 - name of file control.
		2 - HTML css attributes.	
	*/
		function generate_filebox($name,$other=false) {
			$output = "<input type=\"file\" name=\"{$name}\" ".$other.">";
			return $output;
		}

	/* 
		Create textarea from array 
		accept 4 parameters
		1 - name of textarea control.
		2 - value to set in placeholder attribute.
		3 - value to set bydefault in value attribute.
		4 - HTML css attributes.		
	*/
		function generate_textarea($name,$placeholder=false,$default=false,$other=false) {
			$output = "<textarea name=\"{$name}\" placeholder=\"{$placeholder}\" ".$other.">".$default."</textarea>";
			return $output;
		}	

		function mysql_dateformat($str) {
			if(empty($str)) {
				return null;
			}
			$str=str_replace('/', '-', $str);
			$time=strtotime($str);
			if($time) {
				return date('Y-m-d',$time);
			}
			return '';
		}

	/* 
		Date formatting 
		accept 2 parameters
		1 - date which will be convert to format.
		2 - format in which given date will convert. bydefault false.	
	*/
		function dateformat($date,$format=false, $include_time=false) {
			/* Define default date format */
			if(!$format) {
				$format="d M Y";
				/* Include time */
				if($include_time) {
					$format="d M Y h:i A";
				}
			}
			$time=strtotime($date);
			if($date!='0000-00-00' && $date!=null &&  $date!='0000-00-00 00:00:00') {
				return date($format,strtotime($date));
			}
			return '';
		}



	/* 
		add minute in time 
		accept 1 parameter
		1 - integer value as minute to be added on current time.
	*/
		function add_time($min) {
			$now = time();
			$add_time = $now + ($min * 60);
			$end_time = date('Y-m-d H:i:s', $add_time);
			return $end_time;
		}

	/* 
		calculate date difference 
		accept 3 parameter
		1 - smaller date.
		2 - larger date.
		3 - type in which difference will return.
	*/
		function datedifference($date1,$date2,$type='dd') {
			$datetime1 = new DateTime($date1);
			$datetime2 = new DateTime($date2);
			$interval = $datetime2->diff($datetime1);
			if($type='dd') {
				return $interval->format('%a');
			}
			elseif($type='mm') {
				return $interval->format('%m');
			}
			elseif($type='yr') {
				return $interval->format('%y');
			}
			elseif($type='hr') {
				return $interval->format('%h');
			}
		}

	/* 
		invoice no. increment
		accept 1 parameter
		1 - last invoice number.		
	*/
		function increment_invoice_no($matches) {
	  //return ++$matches[1];
			$val=$matches[1];
			$len=strlen($val);
			++$val;
			return str_pad($val, $len, "0", STR_PAD_LEFT);  
		}	

	/* 
		Checking string in array.
		accept 2 parameters
		1 - array
		2 - string which is to be search.
	*/

		function string_inarray($array, $searchingFor) {
			$i=0;
			foreach ($array as $key=>$element) {
				if (strpos($element, $searchingFor) !== false) {
					return array('index'=>$i,'value'=>$key);
				}
				$i++;
			}
			return false;
		}		

	/* 
		Replaces all spaces with hyphens. & Removes special chars. 
		accept 1 parameter
		1 - string need to be clean.		
	*/
		function clean_name($string) {
			$string = str_replace('  ', ' ', $string); 
			$string = str_replace('', '-', $string); 
			return preg_replace('/[^A-Za-z0-9\-\.]/', '', $string);
		}

		/* to remove blank space */
		function clean_field_name($string) {
			$string = preg_replace('/\s+/', ' ',strtolower($string));
	  	$string = str_replace(' ', '_', $string); // Replaces all spaces with hyphens.
	  	return preg_replace('/[^A-Za-z0-9\_\.]/', '', $string);
	  }

	  /* checking user directory */
	  function check_upload_dir($dir) {
	  	/* converting to lowercase */
	  	$dir=strtolower($dir); 

	  	/* seprateing the dir by / */
	  	$dir=explode('/', $dir);

	  	$str_dir='.';
	  	foreach ($dir as $folder_name) {
	  		if(empty($folder_name)) { continue; }
	  		$str_dir.='/'.$folder_name;
	  		if(!file_exists($str_dir) || !is_dir($str_dir)) {
	  			mkdir($str_dir);
	  		}
	  	}

	  	if(!file_exists($str_dir.'/150') || !is_dir($str_dir.'/150')) {
	  		mkdir($str_dir.'/150');
	  	}

	  	if(!file_exists($str_dir.'/300') || !is_dir($str_dir.'/300')) {
	  		mkdir($str_dir.'/300');
	  	}

	  	if(!file_exists($str_dir.'/500') || !is_dir($str_dir.'/500')) {
	  		mkdir($str_dir.'/500');
	  	}
	  }

	/* 
		Checking image directory & thumb directory
		accept 2 parameters
		1 - name of directory.	
		2 - thumb folder name of directory. bydefault false.
	*/
		function check_dir($name,$thumb=false) {
			/* main upload folder */
			if(!file_exists(UPLOAD_DIR) || !is_dir(UPLOAD_DIR)) {
				mkdir(UPLOAD_DIR);
			}

			/* folder of project */
			$document_path='./upload/'.$name;
			if(!file_exists($document_path) || !is_dir($document_path)) {
				mkdir($document_path);
			}

			if($thumb) {
				/* folder of project */
				$thumb_path='./upload/'.$name.'/'.$thumb;
				if(!file_exists($thumb_path) || !is_dir($thumb_path)) {
					mkdir($thumb_path);
				}     
			} 
		}

	/* 
		creating the image thumb 
		accept 5 parameters
		1 - source image path.	
		2 - thumb image width.		
		3 - thumb image height.
		4 - original file name.
		5 - thumb folder path where image thumb is to be create.
	*/
		
	/* 
		get thumb image 
		accept 2 parameters
		1 - image path.
		2 - thumb dimension. bydefault false.
	*/
		function get_thumb($image,$thumb=false) {
			if($image=='') {
				return "";
			}
			$url_array=explode('/',$image);
			$path_array=pathinfo($image);
			$last=count($url_array);
			if($thumb!='') {
				$url_array[$last]=$path_array['filename'].'_thumb.'.$path_array['extension'];
				$url_array[$last-1]=$thumb;
				$thumb_url=implode('/',$url_array);
			}
			else {
				$thumb_url=implode('/',$url_array);
			}
			return $thumb_url;
		}				

		/* Generate otp */
		function generateOTP($length=6) {
			$CI=& get_instance();
			$CI->load->helper('string');
			$password=random_string("numeric",$length);
			return $password;
		}

		/* Generate token */
		function token($length=8) {
			$md5=md5(uniqid(rand(), true));
			return substr($md5,2,$length);
		}		

		function generate_token() {
			$CI=& get_instance();

			$token=token(20);
			if(!empty($token)) {
				$device_data=$CI->api_model->get_device_data($token);
				if(empty($device_data)) {
					return $token;
				}
				else {
					return generate_token();
				}
			}
		}

	/* 
		Parent child array 
		accept 2 parameters
		1 - array.
		2 - parent column name.	
	*/
		function parent_child($array,$parent_col) {
			$return = array();
			$i=0;
			foreach($array as $key=>$row) {
				if(isset($row[$parent_col]) && $row[$parent_col]!='') {
					$return[$row[$parent_col]][] =$row;
				}
				else {
					$return['no_parent'][] =$row;
				}
			}
			return $return;
		}

	/* 
		Parent child array 
		accept 2 parameters
		1 - array.
		2 - parent column name.	
	*/
		function parent_child_array($array,$parent_col, $child_key_col=false) {
			$return = array();
			foreach($array as $key=>$row) {
				if(isset($row[$parent_col]) && $row[$parent_col]!='') {
					if($child_key_col) {
						$return[$row[$parent_col]][$row[$child_key_col]] =$row;
					}
					else {
						$return[$row[$parent_col]][] =$row;
					}
				}
				else {
					if($child_key_col) {
						$return['no_parent'][$row[$child_key_col]]=$row;
					}
					else {
						$return['no_parent'][]=$row;
					}
				}
			}
			return $return;
		}

		function parent_child_array_column($array,$parent_col1, $parent_col2) {
			$return = array();
			foreach($array as $key=>$row) {
				$return[$row[$parent_col1]][$row[$parent_col2]][] =$row;
			}
			return $return;
		}

		function parent_child_array_column_sum($array,$parent_col1, $parent_col2) {
			$return = array();
			foreach($array as $key=>$row) {

				if(empty($return[$row[$parent_col1]][$row[$parent_col2]]['tax_amt'])) {
					$return[$row[$parent_col1]][$row[$parent_col2]]['tax_amt']=0;
				}
				$return[$row[$parent_col1]][$row[$parent_col2]]['tax_amt'] +=$row['tax_amount'];

			}
			return $return;
		}

	/* 
		Replace the text from message 
		accept 2 parameters
		1 - message string.
		2 - array of string that need to be replace.	
	*/
		function replaces($string,$array) {
			foreach($array as $key=>$val) {
				$string=str_replace('|*'.$key.'*|',$val,$string);
			}
			return $string;
		}


	/* 
		Filter for db queries 
		accept 1 parameter
		1 - array of filter.		
	*/
		function apply_filter($filter) {
			$CI=& get_instance();
			if(is_array($filter)) {
				foreach($filter as $key => $val) {
					/* limit */
					if($key==='LIMIT') {
						if(is_array($val)) {
							$CI->db->limit($val[0],$val[1]);
						}
						else {
							$CI->db->limit($val);
						}
					}

					/* Where clause */
					else if($key==='WHERE') {
						if(is_array($val)) {
							foreach ($val as $where_val) {
								$CI->db->where($where_val,null,FALSE);
							}
						}
						else {
							if(!empty($val)) {
								$CI->db->where($val,null,FALSE);
							}
						}
					}
					else if($key==='WHERE_IN') {
						foreach($val as $column => $value) {
							$CI->db->where_in($column,$value);
						}
					}
					else if($key==='WHERE_NOT_IN') {
						foreach($val as $column => $value) {
							$CI->db->where_not_in($column,$value);
						}
					}
					else if($key==='HAVING') {
						if(is_array($val)) {
							foreach($val as $col=>$value) {
								$CI->db->having($col,$value);
							}
						}
						else {
							$CI->db->having($val,null,FALSE);
						}
					}

					/* order by */
					elseif($key=='ORDER_BY') {

						foreach($val as $col => $order) {
							if(is_array($order)) {
								$CI->db->order_by(key($order),current($order),false);
							}
							else {
								$CI->db->order_by($col,$order,false);
							}
						}
					}

					/* group by */
					elseif($key=='GROUP_BY') {
						$CI->db->group_by($val);
					}

					/* group by */
					elseif($key=="SELECT") {
						$CI->db->select($val);
					}

					/* LIKE */
					elseif($key=='LIKE') {
						foreach($val as $col => $value) {
							$CI->db->like($col,$value);
						}
					}

					/* simple key=>value where condtions */
					else {
						$CI->db->where($key,$val);  
					}
				}
			}
		}

	/* Check Unique value form database  
		$value - Column value to check
		$column - Table column name
		$table - Table name
		$primary - Primary key column of table to ignore check unique value for own row 
		$edit_id  - primary column value to ignore that row for unique check
	*/
		function check_unique($value, $column, $table, $primary_column=false ,$edit_id=false, $filter=false) {
			$CI=&get_instance();
			if(!empty($filter)) {
				apply_filter($filter);
			}
			if(!empty($edit_id)) {
				$CI->db->where($primary_column." !=", $edit_id);
			}
			$CI->db->where($column,$value);
			$rs=$CI->db->get($table);
		//print_last_query();die;
			$result=$rs->result_array();
		//print_last_query();die;
			if(isset($result[0])) {
				return false;
			}
			else {
				return true;
			}

		}	

	/* 
		CSV EXPORT 
		accept 2 parameters
		1 - array of record.
		2 - header option.
	*/
		function convertToCSV($data, $options, $name=false) {
			/* setting the csv header*/
			if (is_array($options) && isset($options['headers']) && is_array($options['headers'])) {
				$headers = $options['headers'];
			} 
			else {
				$filename=date('d-M').".csv";
				$headers = array(
					'Content-Type' => 'text/csv',
					'Content-Disposition' => 'attachment; filename="'.$filename.'"'
				);
			}

			$output = '';
			/* setting the first row of the csv if provided in options array */
			if (isset($options['firstRow']) && is_array($options['firstRow'])) {
				$output .= implode(',', $options['firstRow']);
				$output .= "\n"; /* new line after the first line */
			}

			/* setting the columns for the csv. if columns provided, then fetching the or else object keys */
			if (isset($options['columns']) && is_array($options['columns'])) {
				$columns = $options['columns'];
			}
			else {
				if(is_object($data[0])) {
					$objectKeys = get_object_vars($data[0]);
				}
				else {
					$objectKeys = $data[0];	
				}
				$columns = array_keys($objectKeys);
			}

			/* populating the main output string */
			foreach ($data as $row) {
				foreach ($columns as $column) {
					$output .= str_replace(',', ';', $row[$column]);
					$output .= ',';

				//fputcsv($output, $row[$column]);
				}
				$output .= "\n";
			}
		//dsm($output);die;
			/* $file="./".date('d-m-y').".csv"; */
			$file_name=date('d-m-y').".csv";
			if($name) {
				$file_name=$name;
			}
			/* file_put_contents($file,$output); */
			force_download($file_name, $output);  
		}

	/* 
		Currency format 
		accept 1 parameter
		1 - integer to be converted into proper format.
	*/
		function moneyFormatIndia($num){
			$explrestunits = "" ;
			if(strlen($num)>3){
				$lastthree = substr($num, strlen($num)-3, strlen($num));
				$restunits = substr($num, 0, strlen($num)-3); /* extracts the last three digits */
				$restunits = (strlen($restunits)%2 == 1)?"0".$restunits:$restunits; /* explodes the remaining digits in 2's formats, adds a zero in the beginning to maintain the 2's grouping. */
				$expunit = str_split($restunits, 2);
				for($i=0; $i<sizeof($expunit); $i++){
					/* creates each of the 2's group and adds a comma to the end */
					if($i==0) {
						$explrestunits .= (int)$expunit[$i].","; /* if is first value , convert into integer */
					}
					else{
						$explrestunits .= $expunit[$i].",";
					}
				}
				$thecash = $explrestunits.$lastthree;
			} 
			else {
				$thecash = $num;
			}
			return $thecash; /* writes the final format where $currency is the currency symbol. */
		}	

	/* 
		Generate HTTP request
		accept 1 parameter
		1 - url of page.	
	*/
		function httpRequest($url) {
			$pattern = "/http...([0-9a-zA-Z-.]*).([0-9]*).(.*)/";
			preg_match($pattern,$url,$args);
			$in = "";
			$fp = fsockopen($args[1],80, $errno, $errstr, 30);
			if (!$fp) {
				return("$errstr ($errno)");
			} 
			else {
				$args[3] = "C".$args[3];
				$out = "GET /$args[3] HTTP/1.1\r\n";
				$out .= "Host: $args[1]:$args[2]\r\n";
				$out .= "User-agent: PARSHWA WEB SOLUTIONS\r\n";
				$out .= "Accept: */*\r\n";
				$out .= "Connection: Close\r\n\r\n";

				fwrite($fp, $out);
				while (!feof($fp)) {
					$in.=fgets($fp, 128);
				}
			}
			fclose($fp);
			return($in);
		}	

		

	/* 
		Convert Amount to word 
		accept 1 parameter
		1 - integer to be converted into words.		
	*/
		function number_to_words($number) {
			$hyphen      = '-';
			$conjunction = ' and ';
			$separator   = ', ';
			$negative    = 'negative ';
			$decimal     = ' point ';
			$dictionary  = array(
				0                   => 'zero',
				1                   => 'one',
				2                   => 'two',
				3                   => 'three',
				4                   => 'four',
				5                   => 'five',
				6                   => 'six',
				7                   => 'seven',
				8                   => 'eight',
				9                   => 'nine',
				10                  => 'ten',
				11                  => 'eleven',
				12                  => 'twelve',
				13                  => 'thirteen',
				14                  => 'fourteen',
				15                  => 'fifteen',
				16                  => 'sixteen',
				17                  => 'seventeen',
				18                  => 'eighteen',
				19                  => 'nineteen',
				20                  => 'twenty',
				30                  => 'thirty',
				40                  => 'fourty',
				50                  => 'fifty',
				60                  => 'sixty',
				70                  => 'seventy',
				80                  => 'eighty',
				90                  => 'ninety',
				100                 => 'hundred',
				1000                => 'thousand',
				1000000             => 'million',
				1000000000          => 'billion',
				1000000000000       => 'trillion',
				1000000000000000    => 'quadrillion',
				1000000000000000000 => 'quintillion'
			);

			if (!is_numeric($number)) {
				return false;
			}

			if (($number >= 0 && (int) $number < 0) || (int) $number < 0 - PHP_INT_MAX) {
			// overflow
				trigger_error(
					'number_to_words only accepts numbers between -' . PHP_INT_MAX . ' and ' . PHP_INT_MAX,
					E_USER_WARNING
				);
				return false;
			}

			if ($number < 0) {
				return $negative . number_to_words(abs($number));
			}

			$string = $fraction = null;

			if (strpos($number, '.') !== false) {
				list($number, $fraction) = explode('.', $number);
			}

			switch (true) {
				case $number < 21:
				$string = $dictionary[$number];
				break;
				case $number < 100:
				$tens   = ((int) ($number / 10)) * 10;
				$units  = $number % 10;
				$string = $dictionary[$tens];
				if ($units) {
					$string .= $hyphen . $dictionary[$units];
				}
				break;
				case $number < 1000:
				$hundreds  = $number / 100;
				$remainder = $number % 100;
				$string = $dictionary[$hundreds] . ' ' . $dictionary[100];
				if ($remainder) {
					$string .= $conjunction . number_to_words($remainder);
				}
				break;
				default:
				$baseUnit = pow(1000, floor(log($number, 1000)));
				$numBaseUnits = (int) ($number / $baseUnit);
				$remainder = $number % $baseUnit;
				$string = number_to_words($numBaseUnits) . ' ' . $dictionary[$baseUnit];
				if ($remainder) {
					$string .= $remainder < 100 ? $conjunction : $separator;
					$string .= number_to_words($remainder);
				}
				break;
			}

			if (null !== $fraction && is_numeric($fraction)) {
				$string .= $decimal;
				$words = array();
				foreach (str_split((string) $fraction) as $number) {
					$words[] = $dictionary[$number];
				}
				$string .= implode(' ', $words);
			}

			return strtoupper($string);
		}	

	/* 
		Validation rules for controls.
		accept 1 parameter
		1 - value of control.
		2 - define rules for HTML control.
	*/
		function validate($value,$rule) {
			if($rule=="") {
				return true;
			}
			$return=false;
			$arr_value=explode("|", $rule);
			foreach($arr_value as $case_value) {	
				switch($case_value) {
					case "required": 
					if ($value=="") { 
						$return=false;
					} 
					else { 
						$return=true;
					};
					break;
					case "valid_email": 
					if (filter_var($value, FILTER_VALIDATE_EMAIL)) {
						$return=true;
					}
					else {
						$return=false;
					}
					break;
					case "mobile": 
					if(preg_match('/^\d{10}$/',$value)) {
						$return=true;
					}
					else {
						$return=false;
					}
					break;			
					case "numeric":
					if (is_numeric($value)) {
						$return=true;
					} 
					else {
						$return=false;
					}
					break;	
					default: 
					$return=true;

				}
			}
			return $return;
		}	

		if (!function_exists('array_column')) {

	    /**
	     * Returns the values from a single column of the input array, identified by
	     * the $columnKey.
	     *
	     * Optionally, you may provide an $indexKey to index the values in the returned
	     * array by the values from the $indexKey column in the input array.
	     *
	     * @param array $input A multi-dimensional array (record set) from which to pull
	     *                     a column of values.
	     * @param mixed $columnKey The column of values to return. This value may be the
	     *                         integer key of the column you wish to retrieve, or it
	     *                         may be the string key name for an associative array.
	     * @param mixed $indexKey (Optional.) The column to use as the index/keys for
	     *                        the returned array. This value may be the integer key
	     *                        of the column, or it may be the string key name.
	     * @return array
	     */
	    function array_column($input = null, $columnKey = null, $indexKey = null) {
	        // Using func_get_args() in order to check for proper number of
	        // parameters and trigger errors exactly as the built-in array_column()
	        // does in PHP 5.5.
	    	$argc = func_num_args();
	    	$params = func_get_args();

	    	if ($argc < 2) {
	    		trigger_error("array_column() expects at least 2 parameters, {$argc} given", E_USER_WARNING);
	    		return null;
	    	}

	    	if (!is_array($params[0])) {
	    		trigger_error('array_column() expects parameter 1 to be array, ' . gettype($params[0]) . ' given', E_USER_WARNING);
	    		return null;
	    	}

	    	if (!is_int($params[1])
	    		&& !is_float($params[1])
	    		&& !is_string($params[1])
	    		&& $params[1] !== null
	    		&& !(is_object($params[1]) && method_exists($params[1], '__toString'))
	    	) {
	    		trigger_error('array_column(): The column key should be either a string or an integer', E_USER_WARNING);
	    	return false;
	    }

	    if (isset($params[2])
	    	&& !is_int($params[2])
	    	&& !is_float($params[2])
	    	&& !is_string($params[2])
	    	&& !(is_object($params[2]) && method_exists($params[2], '__toString'))
	    ) {
	    	trigger_error('array_column(): The index key should be either a string or an integer', E_USER_WARNING);
	    return false;
	}

	$paramsInput = $params[0];
	$paramsColumnKey = ($params[1] !== null) ? (string) $params[1] : null;

	$paramsIndexKey = null;
	if (isset($params[2])) {
		if (is_float($params[2]) || is_int($params[2])) {
			$paramsIndexKey = (int) $params[2];
		} else {
			$paramsIndexKey = (string) $params[2];
		}
	}

	$resultArray = array();

	foreach ($paramsInput as $row) {

		$key = $value = null;
		$keySet = $valueSet = false;

		if ($paramsIndexKey !== null && array_key_exists($paramsIndexKey, $row)) {
			$keySet = true;
			$key = (string) $row[$paramsIndexKey];
		}

		if ($paramsColumnKey === null) {
			$valueSet = true;
			$value = $row;
		} elseif (is_array($row) && array_key_exists($paramsColumnKey, $row)) {
			$valueSet = true;
			$value = $row[$paramsColumnKey];
		}

		if ($valueSet) {
			if ($keySet) {
				$resultArray[$key] = $value;
			} else {
				$resultArray[] = $value;
			}
		}

	}

	return $resultArray;
}
}

	/* 
		Return Financial Year of date
		$date - Date 
		$year_start - Financial Year start month
	*/
		function get_finacialyear($date=false, $year_start=4) {
			if(!$date) {
				$date=date('Y-m-d');
			}
			$time=strtotime($date);
			$month=date('m',$time);
			$current_year=date('Y',$time);
			$current_yr=date('y',$time);
			if($month >= $year_start) {
				return $current_year.'-'.($current_yr+1);
			}
			else {
				return ($current_year-1).'-'.$current_yr;
			}
		}

		function get_pagination_config() {
			$CI=&get_instance();
			$CI->config->load('pagination', TRUE);
			return $CI->config->config['pagination'];
		}

		function get_pagination_links($total_rows, $other_options=array(), $return_config=true) {
			$CI=&get_instance();
			$CI->load->library('pagination');
			$config=get_pagination_config();
			$config=array_merge($config, $other_options);
			$config['total_rows']=$total_rows;

			/* Set baseurl for pagination */
			if(!isset($config['base_url'])) {
				$config['base_url']=base_url().uri_string()."?";
			}

			$CI->pagination->initialize($config);	
			$links = $CI->pagination->create_links();

			/* Return links with config */
			if($return_config) {
				return array(
					'config'=>$config,
					'links'=>$links
				);
			}
			return $links;
		}


		/* Return bootstrap element label for enable and disable */
		function get_status_markup($status) {
			$status=(string)strtolower($status);
			if(in_array($status, array('0','disable'))) {
				return '<span class="label label-danger">Disable</span>';
			}
			elseif (in_array($status, array('1','enable'))) {
				return '<span class="label label-success">Enable</span>';	
			}
		}



	/* 
		Load view with master view
		$view - View file name of html data
		$view_data - view variables
		$master_view - Master view name
		$html_data - 
			$view is html content - 1
			$view is view file - 0
	*/
			function view_with_master($view,$view_data=false, $master_view=FALSE, $html_data=false) {
				if(empty($master_view)) {
					$master_view=ADMIN_MASTER_VIEW;
				}

				$view_data['view_type']='file';
				if($html_data) {
					$view_data['view_type']='html';
				}

				$view_data['content_view']=$view;
				$CI=&get_instance();
				$CI->load->view($master_view,$view_data);
			}

			/* block theme list */
			function block_theme() {
				$block_theme=array(
					'0'=>'SELECT',
					'1'=>'Left Side',
					'2'=>'Right Side',
					'3'=>'Top Side',
					'4'=>'Bottom Side',
				);

				return $block_theme;
			}

	/* creating the image thumb 
		$image_path - image path
		$width - Thumb width
		$height - Thumb Height
		$thumb_name - Thumb File name 
		$thumb_folder - Thumb folder path
	*/
		function image_thumb($image_path, $width, $height,$thumb_name,$thumb_folder) {
			$CI =& get_instance();
			$image_thumb = $thumb_folder . '/' . $thumb_name;
			if (!file_exists($image_thumb)) {
				$CI->load->library('image_lib');

				/*CONFIGURE IMAGE LIBRARY*/
				$config['image_library']    = 'gd2';
				$config['source_image']     = $image_path;
				$config['new_image']        = $image_thumb;
				$config['create_thumb']     = TRUE;
				$config['maintain_ratio']   = TRUE;
				$config['width']            = $width;
				$config['height']           = $height;
				$CI->image_lib->initialize($config);
				$CI->image_lib->resize();
				$CI->image_lib->clear();
			}
		}

		function generate_image_field($field_control,$name, $help_block='') {
			$div='<div class="row">
			<div class="col-md-6">'.$field_control.$help_block.'</p>
			</div>
			<div class="col-md-6 file-title-container">
			<input type="text" placeholder="File title" name="'.$name.'"class="form-control" value="">
			<p class="help-block">File title</p>
			</div>
			</div>';
			return $div;
		}

		function month() {
			$month=array(
				''=>'Month',
				'January'=>'January',
				'February'=>'February',
				'March'=>'March',
				'April'=>'April',
				'May'=>'May',
				'June'=>'June',
				'July'=>'July',
				'August'=>'August',
				'September'=>'September',
				'October'=>'October',
				'November'=>'November',
				'December'=>'December',
			);

			return $month;
		}

		function time_elapsed_string($datetime, $full = false) {
			$now = new DateTime;
			$ago = new DateTime($datetime);
			$diff = $now->diff($ago);

			$diff->w = floor($diff->d / 7);
			$diff->d -= $diff->w * 7;

			$string = array(
				'y' => 'year',
				'm' => 'month',
				'w' => 'week',
				'd' => 'day',
				'h' => 'hour',
				'i' => 'minute',
				's' => 'second',
			);
			foreach ($string as $k => &$v) {
				if ($diff->$k) {
					$v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
				} else {
					unset($string[$k]);
				}
			}

			if (!$full) $string = array_slice($string, 0, 1);
			return $string ? implode(', ', $string) . ' ago' : 'just now';
		}

		function year() {
			$last_month='2014';

			$current_year=date('Y');

			$year=array();
		//$year['']='Select';
			for ($i=$last_month; $i <=$current_year ; $i++) { 
				$year[$i]=$i;
			}
			return $year;
		}

		function get_youtube_id($url) {
			$matches=array();
			preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $url, $matches);
			if(isset($matches[1])) {
				return $matches[1];
			}
			return false;
		}

		function validate_youtubeurl($url) {
			if(preg_match("/(youtube.com|youtu.be)\/(watch)?(\?v=)?(\S+)?/", $url, $match)){
				return $match[4];
			}else{
				return false;
			}
		}

		function get_youtube_title($id) {
			$content = file_get_contents("http://youtube.com/get_video_info?video_id=".$id);
			parse_str($content, $ytarr);
			if(empty($ytarr['title'])) {
				return '';
			}
			return $ytarr['title'];
		}


	/* 
		Checking string in array.
		accept 2 parameters
		1 - array
		2 - string which is to be search.
	*/

		function checkIfInArrayString($array, $searchingFor) {
			$i=0;
			foreach ($array as $key=>$element) {
				if (strpos($element, $searchingFor) !== false) {
					return array('index'=>$i,'value'=>$key);
				}
				$i++;
			}
			return false;
		}	

		function blood_group() {
			$blood_group=array(
				'A+'=>'A+',
				'O+'=>'O+',
				'B+'=>'B+',
				'AB+'=>'AB+',
				'A-'=>'A-',
				'O-'=>'O-',
				'B-'=>'B-',
				'AB-'=>'AB-',
			);
			return $blood_group;
		}

		function content_type_category() {
			$content_categories=array(
				'content'=>'Template',
				'webform'=>'Webform',
				'section_content'=>'Content'
			);
			return $content_categories;	
		}

		function object_to_array($data) {
			if (is_array($data) || is_object($data)) {
				$result = array();
				foreach ($data as $key => $value) {
					$result[$key] = object_to_array($value);
				}
				return $result;
			}
			return $data;
		}

		/* Read csv file and return its array */
		function get_csv_array($file_path) {
			$row = 1;
			$return_data=array();
			$handle = fopen($file_path, "r");
			if ($handle !== FALSE) {
				while (!feof($handle)) {
					$row_data = fgetcsv($handle);
					if(count($row_data) > 0) {
						$return_data[]=$row_data;
					}
				}
				return $return_data;
				fclose($handle);
			}

			return false;
		}

		function round_number($number, $decimal=false) {
			return number_format((float)$number, $decimal, '.', '');
		}


		function increment_invoice_number($invoice_type=false, $selected_branch_id=false) {
			$CI = get_instance();
			$CI->load->model('setting/setting_model');		
			/* get branch details */

			$branch_id=$CI->session->userdata('branch_id');
			if(!empty($selected_branch_id)) {
				$branch_id=$selected_branch_id;
			}
			$branch=$CI->setting_model->get_branch(array('branch.branch_id'=>$branch_id));

			/* get last entry of jobcard */
			$invoice_number='';
			if($invoice_type=='jobcard') {
				/* Jobcard Prefix */
				$iprefix=$branch[0]['jobcard_prefix'];

				$last_inv=$CI->invoice_model->get_last_quid($branch_id);
				if(!empty($last_inv)) {
					$invoice_number=$last_inv[0]['job_number'];
				}
			}	
			else {
				/* Invoice Prefix */
				$iprefix=$branch[0]['invoice_prefix'];

				$last_inv=$CI->invoice_model->get_last_inid($branch_id);
				if(!empty($last_inv)) {
					$invoice_number=$last_inv[0]['invoice_number'];
				}
			}

			if(!empty($invoice_number)) {
				$invoice_no = increment_string_number($invoice_number, $iprefix);

				while($CI->invoice_model->check_invoice_unique($invoice_no) == false) {
					$invoice_no = increment_string_number($invoice_no, $iprefix);
				}
				return $invoice_no;
			}
			else {
				if(!empty($iprefix)) {
				//return $iprefix.'-1';
					$invoice_no = increment_string_number($invoice_number, $iprefix);
					return $invoice_no;
				}
				else {
					return 'INV-1';
				}			
			}
		}


		/* Function used with increment_invoice_number */
		function increment_string_number($str, $iprefix) {
			$matches=explode('-',$str);
			$increment_no=end($matches);
			$len=strlen($increment_no);
			$invoice_no=(int)$increment_no;
			$invoice_no++;

			/* invoice prefix replace date format %m=month / %d=day / %y=year  */
			$iprefix=str_replace('%m',date('m'),$iprefix);
			$iprefix=str_replace('%d',date('d'),$iprefix);
			$iprefix=str_replace('%y',date('Y'),$iprefix);

			if(!empty($iprefix)) {
				return $iprefix.'-'.$invoice_no;
			}	
			else {
				return 'INV-'.$invoice_no;
			}
		}

		function get_indian_currency($number) {
			$decimal = round($number - ($no = floor($number)), 2) * 100;
			$hundred = null;
			$digits_length = strlen($no);
			$i = 0;
			$str = array();
			$words = array(0 => '', 1 => 'one', 2 => 'two',
				3 => 'three', 4 => 'four', 5 => 'five', 6 => 'six',
				7 => 'seven', 8 => 'eight', 9 => 'nine',
				10 => 'ten', 11 => 'eleven', 12 => 'twelve',
				13 => 'thirteen', 14 => 'fourteen', 15 => 'fifteen',
				16 => 'sixteen', 17 => 'seventeen', 18 => 'eighteen',
				19 => 'nineteen', 20 => 'twenty', 30 => 'thirty',
				40 => 'forty', 50 => 'fifty', 60 => 'sixty',
				70 => 'seventy', 80 => 'eighty', 90 => 'ninety');
			$digits = array('', 'hundred','thousand','lakh', 'crore');
			while( $i < $digits_length ) {
				$divider = ($i == 2) ? 10 : 100;
				$number = floor($no % $divider);
				$no = floor($no / $divider);
				$i += $divider == 10 ? 1 : 2;
				if ($number) {
					$plural = (($counter = count($str)) && $number > 9) ? 's' : null;
					$hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
					$str [] = ($number < 21) ? $words[$number].' '. $digits[$counter]. $plural.' '.$hundred:$words[floor($number / 10) * 10].' '.$words[$number % 10]. ' '.$digits[$counter].$plural.' '.$hundred;
				} else $str[] = null;
			}
			$Rupees = implode('', array_reverse($str));
			$paise = ($decimal) ? "." . ($words[$decimal / 10] . " " . $words[$decimal % 10]) . ' Paise' : '';
			return ($Rupees ? $Rupees . 'Rupees ' : '') . $paise;
		}

		function quotation_status() {
			$quotation_status=array(
				array(
					'key'=>'Draft',
					'value'=>'Draft'
				),
				array(
					'key'=>'Sent',
					'value'=>'Sent'
				),
				array(
					'key'=>'Approved',
					'value'=>'Approved'
				),
				array(
					'key'=>'Reject',
					'value'=>'Reject'
				),
			);
			return $quotation_status;
		}

		function job_work_status() {
			$job_work_status=array(
				'Received'=>'Received',
				'Working'=>'Working',
				'Ready'=>'Ready',
			);

			return $job_work_status;
		}

		function encrypt($value, $key) {
			$iv = '`hVyZWr.SCC5vR.?';
			return openssl_encrypt($value, 'AES-256-CBC', $key,0, $iv);
		}

		function decrypt($value, $key) {

			$iv = '`hVyZWr.SCC5vR.?';
			return openssl_decrypt($value, 'AES-256-CBC',$key,0,$iv);
		}

	/* 
		Replace the text with database variables 
		accept 2 parameters
		1 - value of database.
		2 - company id optional. bydefault false.
	*/
		function database_variable($variable) {
			$CI=& get_instance();
			$CI->db->where('variable_key',$variable);
			$rs=$CI->db->get('variable');

			if($rs->num_rows() > 0) {
				$result=$rs->result_array();
				return $result[0]['variable_value'];
			}
			else {
				return '';
			}
		}

	/* 
		Send SMS 
		accept 3 parameters
		1 - mobile no. on which message to be send.
		2 - message.
		3 - company id optional. bydefault false.
	*/
		function send_sms($mobiles,$message) {
			$CI=& get_instance();


		//$secure_sms=database_variable('secure_sms');
		//dsm($message);die;
			//$message=urlencode($message);

			/*$replace_array=array(
				'username'=>'radiancebeauty2',
				'password'=>'india@2017',
				'sender_id'=>'BEAUTY',
				'mobile'=>$mobiles,
				'message'=>$message,
			);

			$url=replaces(SMSAPP_API_SENDSMS,$replace_array);*/
	    //dsm($url);die;
	    //phpinfo();

		$mobile = $mobiles; //enter Mobile numbers comma seperated
        $username = "emaginationz"; //your username
        $password = "emag@2020"; //your password
        $sender_id = "EMAGNT"; //Your senderid
        $group  = ""; //Your senderid
        $route = "T2"; //Your senderid
        $msgtype = "1"; //Your senderid

		$username = urlencode($username);
        $password = urlencode($password);
        $sender = urlencode($sender_id);
        $message = urlencode($message);
        $url="http://smsnew.brandexindia.in/httpapi/smsapi?uname=$username&password=$password&sender=$sender&receiver=$mobile&group=$group&route=$route&msgtype=$msgtype&sms=$message";

	    $response=curl_send($url);
	    return $response;
	    /*
	    //dsm($response);die;
	    if(strpos(strtolower($response),'sent') === false) {
	    	return false;
	    }
	    else {
	    	return true;
	    }*/
	}

	function decode_token($id) {
		include APPPATH.'/libraries/HashGenerator.php';
		include APPPATH.'/libraries/Hashids.php';
		
		//$CI->load->library("Hashids");
		$hashids = new Hashids\Hashids('ZzPXFYNSHBP4SreeyrKS',6);

		return $hashids->decode($id);
	}

	function encode_token($id) {
		include APPPATH.'/libraries/HashGenerator.php';
		include APPPATH.'/libraries/Hashids.php';
		
		//$CI->load->library("Hashids");
		$hashids = new Hashids\Hashids('ZzPXFYNSHBP4SreeyrKS',6);

		return $hashids->encode($id);
	}

	/* Round of number
		1.val
		The value to round

		2.precision
		The optional number of decimal digits to round to.

		3.mode
		Use one of the following constants to specify the mode in which rounding occurs.
	*/
		function round_amount($amount, $precision=false,  $mode=false) {
			$round_amount = round($amount, $precision, $mode);
			return $round_amount;
		}

	/* 
		Create combobox from array 
		accept 7 parameter.
		1 - name of select box or combobox.
		2 - array of values.
		3 - option value of select box or combobox.
		4 - text which will display in select box or combobox.
		5 - bydefault selected value in select box or combobox.
		6 - HTML css attributes.
		7 - 'SELECT' will be first option or not.
	*/
		function generate_combobox($name,$array,$key,$value,$selected=false,$other=false,$defaultoption=true) {
			if(empty($array)) {
				$output = "<select name=\"{$name}\" ".$other.">";
				if($defaultoption) {
					$output .= "<option value=\"\">SELECT</option>";    
				}
				$output .= "</select>";
			}
			else{  
				$output = "<select name=\"{$name}\" ".$other.">";
				if($defaultoption) {
					$output .= "<option value=\"\">SELECT</option>";    
				}
				$keys=array_column($array,$key);
				if(is_array($value)) {
					$args=array();
					$args[]="combine";
					foreach($value as $val) {
						$args[]=array_column($array,$val);
					}
					$vals=call_user_func_array('array_map',$args);
				}
				else {
					$vals=array_column($array,$value);
				}

				$new_array=array_combine($keys,$vals);

				foreach ($new_array as $key => $value) {
					if(is_array($selected)) {
						if (in_array($key,$selected)) {
							$output .= "<option value=\"{$key}\" selected>{$value}</option>";
						} 
						else {
							$output .= "<option value=\"{$key}\">{$value}</option>";
						}
					}
					else {
						if ($selected !== false && $selected == $key) {
							$output .= "<option value=\"{$key}\" selected>{$value}</option>";
						} 
						else {
							$output .= "<option value=\"{$key}\">{$value}</option>";
						}
					}
				}

				$output .= "</select>";
			}
			return $output;
		}	

	/* 
		Create combobox from array 
		accept 7 parameter.
		1 - name of select box or combobox.
		2 - array of values.
		3 - option value of select box or combobox.
		4 - text which will display in select box or combobox.
		5 - bydefault selected value in select box or combobox.
		6 - HTML css attributes.
		7 - 'SELECT' will be first option or not.
		8 - array('Attributr name','array or string','saperator') -
			 ex1. array('data-opt',invoice_value')
			 ex2. array('data-opt',array('invoice_value','invoice_numver'),',')
	*/
			 function generate_combobox_attr($name,$array,$key,$value,$selected=false,$other=false,$defaultoption=true,$datavalue=false) {
		//dsm(func_get_args());
			 	if(empty($array)) {
			 		$output = "<select name=\"{$name}\" ".$other.">";
			 		if($defaultoption) {
			 			$output .= "<option value=\"\">SELECT</option>";    
			 		}
			 		$output .= "</select>";
			 	}
			 	else{  
			 		$output = "<select name=\"{$name}\" ".$other.">";
			 		if($defaultoption) {
			 			$output .= "<option value=\"\">SELECT</option>";    
			 		}
			 		$keys=array_column($array,$key);
			 		$sap_char=' ';			
			 		if(is_array($value)) {
			 			$args=array();
			 			$args[]="combine";
			 			foreach($value as $val) {
			 				$args[]=array_column($array,$val);
			 			}

			 			/* pass saperator array */
			 			foreach ($args[1] as $key=>$value) {
			 				$saperator[$key]=$sap_char;
			 			}
			 			$args[]=$saperator;
			 			$vals=call_user_func_array('array_map',$args);
			 		}
			 		else {
			 			$vals=array_column($array,$value);
			 		}
			 		$new_array=array_combine($keys,$vals);

			 		$opt_attr=array();

			 		/* for setting extra attribute with dynamic value */
			 		if($datavalue) {
			 			/* attribute name */
			 			$attr=$datavalue[0];
			 			/* attribute value column */
			 			$attr_value=$datavalue[1];
			 			/* create separator array */
			 			$data_saperator=array();

			 			/* if multiple column value need to supply */
			 			if(is_array($attr_value)) {
			 				/* column value separator  */
			 				$datasap_char=$datavalue[2];
			 				$val_columns=array();
			 				$val_columns[]="combine";

			 				/* add each column value into val column */
			 				foreach($attr_value as $attr_val) {
			 					$val_columns[]=array_column($array,$attr_val);
			 				}

			 				/* pass separator array */
			 				foreach ($attr_value as $key=>$blank) {
			 					$data_saperator[$key]=$datasap_char;
			 				}
			 				$val_columns[]=$data_saperator;

			 				/* combine multiple column in to string */
			 				$opt_attr=call_user_func_array('array_map',$val_columns);

			 			}
			 			else {
			 				$opt_attr=array_column($array,$attr_value);
			 			}
			 		}

			 		$k=0;
			 		foreach ($new_array as $key => $value) {
			 			$str_attr='';
			 			if($datavalue) {
			 				$str_attr=' '.$datavalue[0].'="'.$opt_attr[$k].'" ';
			 			}
			 			if(is_array($selected)) {
			 				if (in_array($key,$selected)) {
			 					$output .= "<option value=\"{$key}\" ".$str_attr." selected>{$value}</option>";
			 				} 
			 				else {
			 					$output .= "<option value=\"{$key}\" ".$str_attr.">{$value}</option>";
			 				}
			 			}
			 			else {
			 				if ($selected !== false && $selected == $key) {
			 					$output .= "<option value=\"{$key}\" ".$str_attr." selected>{$value}</option>";
			 				} 
			 				else {
			 					$output .= "<option value=\"{$key}\" ".$str_attr.">{$value}</option>";
			 				}
			 			}
			 			$k++;
			 		}

			 		$output .= "</select>";
			 	}
			 	return $output;
			 }

			 function send_sms_customer($invoice_id, $action=false) {
			 	$CI=& get_instance();

			 	$filter_invoice['invoice.invoice_id']=$invoice_id;
			 	$invoice_detail=$CI->invoice_model->get_common_invoice($filter_invoice);
		//dsm($invoice_detail);die;

			 	$customer_mobile=$invoice_detail[0]['customer_mobile'];

		// send sms
			 	if($action=='send_sms') {
			 		if($invoice_detail[0]['invoice_type']=='invoice') {
			 			$invoice_send_sms=database_variable('invoice_send_sms');

			 			$replace_array=array(
			 				'display_name'=>$invoice_detail[0]['display_name'],
			 				'invoice_number'=>$invoice_detail[0]['invoice_number'],
			 				'total_amount'=>$invoice_detail[0]['total_amount'],
			 				'vehicle_number'=>$invoice_detail[0]['vehicle_number'],
			 				'business_name'=>$invoice_detail[0]['business_name'],
			 				'url'=>str_replace('http://','',base_url()).'invoice/share/print_invoice/'.encode_token($invoice_id),
			 			);
			 			$message=replaces($invoice_send_sms, $replace_array);
			 		}

			 		if($invoice_detail[0]['invoice_type']=='jobcard') {
			 			$jobcard_send_sms=database_variable('jobcard_send_sms');

			 			$replace_array=array(
			 				'display_name'=>$invoice_detail[0]['display_name'],
			 				'job_number'=>$invoice_detail[0]['job_number'],
			 				'total_amount'=>$invoice_detail[0]['total_amount'],
			 				'vehicle_number'=>$invoice_detail[0]['vehicle_number'],
			 				'business_name'=>$invoice_detail[0]['business_name'],
			 				'url'=>str_replace('http://','',base_url()).'invoice/share/jobcard_share_link/'.encode_token($invoice_id),
			 			);
			 			$message=replaces($jobcard_send_sms, $replace_array);
			 		}
			 	}

			 	if($action=='send_sms_payment') {

			 	}

			 	send_sms($customer_mobile, $message);
			 }

			 function intRandom($size) {
			 	$validCharacters = utf8_decode("0123456789434323");
			 	$validCharNumber = strlen($validCharacters);
			 	$int = '';
			 	while (strlen($int) < $size) {
			 		$index = mt_rand(0, $validCharNumber - 1);
			 		$int .= $validCharacters[$index];
			 	}
			 	return $int;
			 }

			 function api_send_sms($mobile_no,$message) {     
			 	$CI=& get_instance();  
			 	$replace_array=array('mobile'=>$mobile_no,'message'=>urlencode($message));    
			 	$url=margetag_replaces(SMS_URL,$replace_array);
			 	return $response=curl_send($url); 
			 }

			 function margetag_replaces($string,$array) {  
			 	foreach($array as $key=>$val) {   
			 		$string=str_replace('|*'.$key.'*|',$val,$string);  
			 	}  return $string; 
			 }

			 function is_multi_array($a) {
			 	$rv = array_filter($a,'is_array');
			 	if(count($rv)>0) return true;
			 	return false;
			 }


			 function get_header_param($key) {
			 	$header_param = getallheaders();
			 	$header_param = array_change_key_case($header_param);
		//dsm($header_param);
			 	if(isset($header_param[$key])) {
			 		return $header_param[$key];
			 	}
			 	return null;
			 }

			 function get_token_customer_id($device_token) {
			 	$CI=& get_instance(); 

		// get customer detail
			 	$filer_customer = [
			 		'app_user_login.device_token'=>$device_token,
			 		'customer.is_verified'=>1,
			 	];
			 	$data['customer_detail']=$CI->api_model->get_user_device($filer_customer);
			 	if(empty($data['customer_detail'])) {
			 		return '';
			 		die;
			 	}
			 	return $data['customer_detail'][0]['customer_id'];
			 }

			 function get_category_title($category_id) {
			 	$CI=& get_instance(); 

			 	$filter_subcategory['item_category.item_category_id']=$category_id;
			 	$data['subcategory_list']=$CI->setting_model->get_item_category($filter_subcategory);

			 	if(!empty($data['subcategory_list'])) {

			 		$filter_category['item_category.item_category_id']=$data['subcategory_list'][0]['parent_category'];
			 		$data['category_list']=$CI->setting_model->get_item_category($filter_category);

			 		return $data['category_list'][0]['category_title'];
			 	}
			 }

			 function get_subcategory_title($category_id) {
			 	$CI=& get_instance(); 

			 	$filter_category['item_category.item_category_id']=$category_id;
			 	$data['category_list']=$CI->setting_model->get_item_category($filter_category);

			 	if(!empty($data['category_list'])) {
			 		return $data['category_list'][0]['category_title'];
			 	}
			 }

			 function get_login_otp_message($otp) {
			 	return '<#> Your login OTP for Autonism is: '.$otp.' Op4wNXXm3uT';
			 }

			 function push_notification($notification_data,  $token) {

			 	define('API_ACCESS_KEY', 'AIzaSyBSvdM8w7qoMu-RNpyFzqYKW_JRsvVyOmk');
			 	$fcmUrl = 'https://fcm.googleapis.com/fcm/send';
			 	$token = $token;

			 	$notification = [
			 		'title' => $notification_data['notification_title'],
			 		'body' => $notification_data['notification_data'],
			 		'invoice_id' => $notification_data['invoice_id'],
			 		'user_id' => $notification_data['customer_id'],
			 		'notification_id' => $notification_data['notification_id'],
            //'icon' => "myIcon",
            //'sound' => "mySound",
			 	];

			 	$extraNotificationData = ["message" => $notification, "moredata" => ''];

			 	$registration_ids=['AAAA5kPdSDE:APA91bHW3bGvYY-trxgMZvOz4NV509EuoeOkIymGiykJduYd7_aVB116BVwOrPt7gN4Jg77PKw7Ca6fDhF_Rb5IAUkIn9csthWoN8zpxxK02HQhsrDv57SVLP29gm32EQ9NN3_219VBd'];

			 	$fcmNotification = [
            //'registration_ids' => $registration_ids,
            'to' => $token, //single token
            //'notification' => $notification,
            'data' => $notification
        ];

        $headers = [
        	'Authorization: key=' . API_ACCESS_KEY,
        	'Content-Type: application/json'
        ];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $fcmUrl);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fcmNotification));
        $result = curl_exec($ch);
        //dsm($result);die;
        curl_close($ch);
    }

    function send_notification($notification) {
    	$CI = &get_instance();

    	$notification_data=$notification;
    	$notification_data['created_at']=date('Y-m-d H:i:s');
    	$CI->db->insert('notification',$notification_data);
    	return $CI->db->insert_id();
    }

    function send_notification_with_push($notification, $token) {
    	$notification_id=send_notification($notification);
    	$notification['notification_id']=$notification_id;
    	push_notification($notification, $token);
    }

    function get_firebase_token($customer_id) {
    	$CI = &get_instance();

    	$CI->load->model('customer_model');
    	$customer_detail=$CI->customer_model->get_app_customer_login(['app_user_login.app_user_id'=>$customer_id]);
    	if(empty($customer_detail)) {
    		return '';
    	}
    	return $customer_detail[0]['firebase_token'];
    }

    function get_master_value() {
    	$master_value=[
    		''=>'SELECT',
    		'religion'=>'Religion',
    		'nationality'=>'Nationality',
    		'marital_status'=>'Marital status',
    		'bank_account_type'=>'Bank account type',
    		'bank'=>'Bank',
    		'qualification_level'=>'Qualification level',
    		'blood_group'=>'Blood group',
    		'employment_status'=>'Employment status',
    		'leaving_reason'=>'Leaving reason',
    		'department'=>'Department',
    		'designation'=>'Designation',
    		'category'=>'Category',
    		'grade'=>'Grade',
    		'leaving_reason'=>'Leaving reason',
    		'leave_reason'=>'Leave reason',
    		'employment_status'=>'Leave reason',
    	];
    	return $master_value;
    }

    function social_type() {
    	$social_type=[
    		''=>'SELECT',
    		'google'=>'Google',
    		'facebook'=>'Facebook',
    		'justdial'=>'Justdial',
    	];
    	return $social_type;
    }

    function client_package_check() {
    	$CI = &get_instance();
    	$CI->load->model('client/client_model');
    	$today=date('d-m-Y');
    	/*$role_title=$CI->session->userdata('role_title');
    	if($role_title!='Client') {
    		return '';
    	}*/

    	$client_id=$CI->session->userdata('client_id');
    	$filter_client['store.client_id']=$client_id;
    	$store_list=$CI->client_model->get_store($filter_client);

    	if(!empty($store_list)) {
    		$store_cnt=0;
    		foreach ($store_list as $key => $row) {
    			if(dateformat($row['end_date'])<$today || $row['deleted_at']!=NULL) {
    				$store_cnt++;
    				set_message('Your '.$row['store_title'].' store package is expired.');
    				if(count($store_list)==$store_cnt) {
    					redirect(base_url().'dashboard');
    				}
    			}
    		}
    	}

    }

    function get_bank_account_type() {
    	$bank_account_type=[
    		''=>'Select Account type',
    		'Current Account'=>'Current Account',
    		'Savings Account'=>'Savings Account',
    		'Recurring Deposit Account'=>'Recurring Deposit Account',
    		'Fixed Deposit Account'=>'Fixed Deposit Account',
    	];
    	return $bank_account_type;
    }

    function get_week_day() {
    	$week_day=[
    		''=>'Select week day',
    		'Monday'=>'Monday',
    		'Tuesday'=>'Tuesday',
    		'Wednesday'=>'Wednesday',
    		'Thursday'=>'Thursday',
    		'Friday'=>'Friday',
    		'Saturday'=>'Saturday',
    		'Sunday'=>'Sunday',
    	];

    	return $week_day;
    }

    function prior_pause_tiffin(){
    	$pause_tiffin_option=[
    		'1'=>'1 days',
    		'2'=>'2 days',
    		'3'=>'3 days',
    		'4'=>'4 days',
    		'5'=>'5 days',
    		'6'=>'6 days',
    		'7'=>'7 days',
    	];
    	return $pause_tiffin_option;
    }

    /* 
		CURL Execution
		accept 1 parameter.
		1 - url where page will send the request.
	*/
		function curl_send($url, $type='json') {

			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4 );
			curl_setopt($ch, CURLOPT_ENCODING,  '');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		//curl_setopt($ch, CURLOPT_HTTPHEADER, $request_headers);
		//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			$data = curl_exec($ch);

			if (curl_errno($ch)){
				$error= curl_error($ch);
				return $error;
			} else{
			// Show me the result
				if($type=='xml') {
					dsm($data);
					$transaction=$data;
					if(!empty($data)) {
						$transaction = (array) simplexml_load_string(trim($data));
					}
				//$transaction = $arr = (array) $data -> xpath('xml');
				}
				else {
					$transaction = json_decode($data, TRUE);
				}
				curl_close($ch);
				return $transaction;
			}
		}	

		function get_review_star($avg_rating) {
			$whole = floor($avg_rating);      // 1
			$fraction = $avg_rating - $whole; // .25
			$rated_star=round($avg_rating);
			$unrated_star=5-round($avg_rating);

			if($fraction>='0.5'){
				$rated_star=$rated_star-1;
			}

			for($i=1;$i<=$rated_star;$i++) {
				echo '<i class="fa fa-star text-warning" ></i>';
			}

			if($fraction>='0.5'){
				echo '<i class="fa fa-star-half-o text-warning" ></i>';
			}

			for($i=1;$i<=$unrated_star;$i++) {
				echo '<i class="fa fa-star-o text-warning" ></i>';
			}
		}

		function file_upload($column, $division='', $valid_ext='image') {
			$CI =& get_instance();
			if($valid_ext=='image') {
				$allowed_types='gif|jpg|jpeg|png';
			}
			if($valid_ext=='document') {
				$allowed_types='xlx|xlxs|pdf|doc|docx|txt';
			}
			if($valid_ext=='zip') {
				$allowed_types='zip|rar';
			}
			if($valid_ext=='video') {
				$allowed_types='mp4|wav|mvk|3gp';
			}

			$poster_path='';
			$poster_img_path=$column;
			$year=date('Y');
			/* folder path with date and user mail id */
			$pic_file = UPLOAD_DIR.$year.'/'.$poster_img_path.'/';
			if(!empty($division)) {
				$pic_file = UPLOAD_DIR.$year.'/'.url_title($division).'/'.$poster_img_path.'/';
			}

			/* logo Upload file */
			$upload_config['upload_path']= $pic_file;
			$upload_config['allowed_types']= $allowed_types;
			//$upload_config['max_size'] = '1024';
			$upload_config['file_ext_tolower']= true;
			$upload_config['overrite']= FALSE;

			/* Check if upload folder available */
			if(!file_exists($upload_config['upload_path'])) {
				mkdir($upload_config['upload_path'], 0777, true);
			}

			/* Upload profile pic file */
			$CI->load->library('upload', $upload_config);
			$CI->upload->initialize($upload_config);
			if(!empty($_FILES[$column]['name'])) {
				if (!$CI->upload->do_upload($column)) {
					set_message($CI->upload->display_errors());
					$CI->session->set_flashdata('old_data',$CI->input->post());
					redirect_back();
				}
				else {
					$upload_data=$CI->upload->data();
					//dsm($upload_data);
					$poster_path=$upload_config['upload_path'].$upload_data['file_name'];
				}
			}
			return $poster_path;
		}

		function file_upload_mobile($column, $division='', $valid_ext='image') {
			$CI =& get_instance();
			if($valid_ext=='image') {
				$allowed_types='gif|jpg|jpeg|png';
			}
			if($valid_ext=='document') {
				$allowed_types='xlx|xlxs|pdf|doc|docx|txt';
			}
			if($valid_ext=='zip') {
				$allowed_types='zip|rar';
			}
			if($valid_ext=='video') {
				$allowed_types='mp4|wav|mvk|3gp';
			}

			$poster_path='';
			$poster_img_path=$column;
			$year=date('Y');
			/* folder path with date and user mail id */
			$pic_file = UPLOAD_DIR.$year.'/'.$poster_img_path.'/';
			if(!empty($division)) {
				$pic_file = UPLOAD_DIR.$year.'/'.url_title($division).'/'.$poster_img_path.'/';
			}

			/* logo Upload file */
			$upload_config['upload_path']= $pic_file;
			$upload_config['allowed_types']= $allowed_types;
			//$upload_config['max_size'] = '1024';
			$upload_config['file_ext_tolower']= true;
			$upload_config['overrite']= FALSE;

			/* Check if upload folder available */
			if(!file_exists($upload_config['upload_path'])) {
				mkdir($upload_config['upload_path'], 0777, true);
			}

			/* Upload profile pic file */
			$CI->load->library('upload', $upload_config);
			$CI->upload->initialize($upload_config);
			if(!empty($_FILES[$column]['name'])) {
				if (!$CI->upload->do_upload($column)) {

					$this->send_response([
						'status' => true,
						'message' => $CI->upload->display_errors(),
					]);
				}
				else {
					$upload_data=$CI->upload->data();
					//dsm($upload_data);
					$poster_path=$upload_config['upload_path'].$upload_data['file_name'];
				}
			}
			return $poster_path;
		}

		function post_type() {
			$post_type=array(
				'post'=>'Post',
				'contest'=>'Contest',
			);

			return $post_type;
		}

		/**
     * Send to a single device
     */
    function sendNotification($token, $title, $message, $image){
    	$CI =& get_instance();
        //$token = 'cg-89Qh4qEs:APA91bGUBLfJKar3_qCUohijRXWEuOMJplpp0KXzTXm5yMlymMWXcwvpIKbz-9mAov0N_SZk2aWiTTzrvKtmFYZaLzUoR4naKfiiPLt6LUeRJdt8n-I5GnU2d57YgMeKvkpKE7ZNmVXq'; // push token

        //$message = "Test notification message";

        $CI->load->library('fcm');
        $CI->fcm->setTitle($title);
        $CI->fcm->setMessage($message);
        $CI->fcm->setIsBackground(true);

        $payload = array('delivery_receipt_requested' => true);
        $CI->fcm->setPayload($payload);

        $data = $CI->fcm->getPush();

        $notification = array(
            'title'     => $title,
            'body'   => $message,
            'is_background'     => false,
            'vibrate'   => 1,
            'sound'     => 1,
            'delivery_receipt_requested'=>true,
        );
        if(!empty($image)) {
        	$notification['image']=base_url().$image;
        	//$notification['image']="https://emaginationz.net/projects/marathi_cinema/./uploads/2020/post_img/91910102_144173337139803_5272587760505454592_o1.jpg";
        	//$notification['icon']=$image;
        }

        if($token=='all') {
        	$p = $CI->fcm->sendToTopic($token, $notification, $data);
        }
        else if(is_array($token) && $token!='all') {
        	 $p = $CI->fcm->sendMultiple($token, $notification, $data);
        	 
        }
        else {
        	 $p = $CI->fcm->send($token, $notification, $data);
        }
    }

    function timeAgo($time_ago) {
	    $time_ago = strtotime($time_ago);
	    $cur_time   = time();
	    $time_elapsed   = $cur_time - $time_ago;
	    $seconds    = $time_elapsed ;
	    $minutes    = round($time_elapsed / 60 );
	    $hours      = round($time_elapsed / 3600);
	    $days       = round($time_elapsed / 86400 );
	    $weeks      = round($time_elapsed / 604800);
	    $months     = round($time_elapsed / 2600640 );
	    $years      = round($time_elapsed / 31207680 );
	    // Seconds
	    if($seconds <= 60){
	        return "just now";
	    }
	    //Minutes
	    else if($minutes <=60){
	        if($minutes==1){
	            return "one minute";
	        }
	        else{
	            return "$minutes minutes";
	        }
	    }
	    //Hours
	    else if($hours <=24){
	        if($hours==1){
	            return "an hour";
	        }else{
	            return "$hours hrs";
	        }
	    }
	    //Days
	    else if($days <= 7){
	        if($days==1){
	            return "yesterday";
	        }else{
	            return "$days days";
	        }
	    }
	    //Weeks
	    else if($weeks <= 4.3){
	        if($weeks==1){
	            return "a week";
	        }else{
	            return "$weeks weeks";
	        }
	    }
	    //Months
	    else if($months <=12){
	        if($months==1){
	            return "a month";
	        }else{
	            return "$months months";
	        }
	    }
	    //Years
	    else{
	        if($years==1){
	            return "one year";
	        }else{
	            return "$years years";
	        }
	    }
	}

	if (!function_exists('getallheaders')) {
        function getallheaders() {
            $headers = [];
            foreach ($_SERVER as $name => $value) {
                if (substr($name, 0, 5) == 'HTTP_') {
                    $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
                }
            }
            return $headers;
        }
    }
      

    