<?php include("head.php"); ?>
<?php include("navigation.php"); ?>
  
    <!-- ========== Header end ========== -->
    <!-- ========== All events hero start ========== -->
    <section
      id="all-events"
      class="all-blogs hero__padding overflow-hidden position-relative bg-one "
    >
      <div class="container">
        <div class="row">
          <div class="blog-title">
            <h1
              class="display-3"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="600"
            >
              Crossword Puzzle
            </h1>
          </div>
        </div>
      </div>
    </section>
    <!-- ========== All events hero end ========== -->
    <!-- ========== All events section start ========== -->
    <div class="section-padding events pd-bt0">
      <div class="container">
        <div class="row">
          <div class="col-md-12 col-lg-12" data-aos="fade-up" data-aos-duration="1000" data-aos-delay="200">
               
               <h3>CROSSWORD #<?php echo $crossword[0]['puzzle_number']?>: <?php echo $crossword[0]['puzzle_name']?></h3>
               <p class="d-flex"><span class="bt-bt"><span class="clr-blue">Published on:</span> <?php echo date("F d,Y", strtotime($crossword[0]['puzzle_date']));?></span>
                <span class="mrlft-20">
                    <?php
               $id= $this->uri->segment(1);
                if(!empty($id))
                {?>
                    <a class="d-desk" href="https://web.whatsapp.com/send?text=Crossword%20Link%3A%20<?php echo urlencode(base_url().$id)?>"><i class="fa-solid fa-square-share-nodes share-fontsize"></i></a>
                    <a class="d-mob" href="https://wa.me?text=Crossword%20Link%3A%20<?php echo urlencode(base_url().$id)?>"><i class="fa-solid fa-square-share-nodes share-fontsize"></i></a>
                    
               <? }
                else
                {?>
                   
                   <a class="d-desk" href="https://web.whatsapp.com/send?text=Crossword%20Link%3A%20<?php echo urlencode(base_url())?>"><i class="fa-solid fa-square-share-nodes share-fontsize"></i></a>
                    <a class="d-mob" href="https://wa.me?text=Crossword%20Link%3A%20<?php echo urlencode(base_url())?>"><i class="fa-solid fa-square-share-nodes share-fontsize"></i></a>
            <?php }
               
               ?>
                </span>
               </p>
               
               
              <!--  <p>Category: Sports <span class="vline">|</span> Type: Medium <span class="vline">|</span> Sort By: Newest</p> -->
               <!-- Embed Link -->
               <embed  src="<?php echo $crossword[0]['puzzle_iframe_url']?>" width="100%" height="450">
               <!-- Embed Link -->
          </div>
        </div>
      </div>

    </div>

<div id="single-blog" class="single-blog">
      <div class="container">
        <div class="row">
          <div class="col-lg-10 offset-lg-1">
            
            <a href="#" data-bs-toggle="modal" data-bs-target="#commentModal" >Comments</a>
            <div class="single-blog__comment">
             
            </div>
          </div>
        </div>
      </div>
    </div>


      


  <?php include("modal.php"); ?>

     <!-- ========== comment section start ========== -->
      
    <!-- ========== comment section end ========== -->

    <!-- ========== All events section end ========== -->
      <!-- ========== Author section start ========== -->
      <section id="about" class="section-padding authorv2  bg-one">
        <div class="container">
          <div class="row gx-5 d-flex">
            <div
              class="col-lg-3 mb-4 mb-lg-0 "
              data-aos="fade-right"
              data-aos-duration="1000"
              data-aos-delay="200"
            >
              <div class="">
                <img class=""src="<?php echo base_url()?>assets/images/cw/mangesh-ghogre.jpg"
                  alt="Mangesh Ghogre" width="100%"
                />
              </div>
            </div>
            <div
              class="col-lg-9"
              data-aos="fade-left"
              data-aos-duration="1000"
              data-aos-delay="200"
            >
              <h4 class="display-3"><span class="br-after">Mangesh Ghogre:</span></h4>
              <p>Mangesh Ghogre is a crossword constructor who has had crosswords published in The New York Times, The Wall Street Journal, The Los Angeles Times, Games and World of Puzzles. With a career spanning over 25 years, Mangesh is currently the editor and constructor for the weekly Mini Crossword in The Economic Times.</p> 
             <p>Ghogre was recognized as the first India-based crossword constructor for the Los Angeles Times in 2010 and The New York Times in 2013. In 2012, he became the first Indian to judge American Crossword Puzzle Tournament, world's oldest and largest crossword tournament, held in New York.</p> 
            <p>In 2014, his crossword work was showcased at a solo exhibition at an art gallery at the well-known Kala Ghoda Arts Festival in Mumbai for 9 days. </p>
            <p>Some of his marquee crosswords include Fourth of July-themed crossword in NYT in 2017 to celebrate American independence day, Mahatma Gandhi-themed crossword in NYT in 2019 to celebrate Gandhi's 150th birth anniversary and Taj Mahal-themed crossword in 2023 to celebrate Indian independence day. </p>
          <p>In 2019, he was awarded the Rotary Excellence Award for distinct achievements in his professional and vocational life. 
            In 2022, he moved from Mumbai to the US after he was granted the prestigious Einstein Visa for his extraordinary skills in making crosswords. </p>
          <p>Professionally, Mangesh is an investment banker with 2 decades of rich experience in raising global equity of over USD 50 Billion. In 2019, he was featured in the Fortune 40 under 40 list of best professionals and entrepreneurs in India. He has been interviewed on Bloomberg Asia, CNBC, Fortune, Economic Times for his expertise on investment banking and capital markets.
        </p>
         <p>Mangesh is also a prolific writer with editorial columns published in The Times of India, The Economic Times, The Hindu Business Line and Deccan Herald. His columns have been featured in The Speaking Tree column in The Times of India.
        </p>
        <p>Mangesh has completed his Bachelors of Engineering from VJTI (University of Mumbai) and MBA from NMIMS (University of Mumbai). </p>

              
            </div>
          </div>
        </div>
      </section>
      <!-- ========== Author section end ========== -->
      <!-- ========== Events section end ========== -->
      <section id="events" class="section-padding event">
        <div class="container">
          <div class="row">
            <div class="col-xl-6 offset-xl-3 col-lg-10 offset-lg-1">
              <div class="section-title-center text-center">
                
                <h2
                  class="display-3"
                  data-aos="fade-up"
                  data-aos-duration="1000"
                  data-aos-delay="200"
                >
                  Latest Articles
                </h2>
                <div
                  class="section-divider divider-traingle"
                  data-aos="fade-up"
                  data-aos-duration="1000"
                  data-aos-delay="250"
                ></div>
              </div>
            </div>
          </div>
          <div class="row row-cols-1 row-cols-sm-2 row-cols-lg-3 g-3">
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="200"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-1.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p>August 17, 2023</p>
                  </div>
                  <h4 class="mb-3">This I-banker moved to the US on a permanent 'Einstein' visa—for his crossword skills</h4>
                  <p>
                    Mangesh Ghogre, former executive director and head of equity capital markets at Nomura India, made it to the US on an Einstein visa, given for 'extraordinary abilities'. He is the first Indian to have constructed a crossword for The New York Times, and most recently, published a Taj-Mahal crossword ode in the paper, themed around India's Independence Day...
                  </p>
                </div>
                <a href="https://www.forbesindia.com/article/lifes/this-ibanker-moved-to-the-us-on-a-permanent-einstein-visafor-his-crossword-skills/87577/1" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
                </div>
                
              </div>
            </div>
            
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="400"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-2.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p>March 13, 2023</p>
                  </div>
                  <h4 class="mb-3">How crosswords made Mangesh Ghogre America's 'Einstein' - Times of India</h4>
                  <p>
                   It all began with him and his classmates picking up The Times of India crossword in the hope that it would improve their vocabulary and help them crack the GMAT</p>
                   <p>Back in 1997, like most other engineering students of his generation, Mangesh Ghogre dreamt of moving to the US. Today, he has made his dream...</p>
                </div>
                <a href="https://timesofindia.indiatimes.com/world/us/how-this-desi-i-banker-cracked-global-crossword-club-clue-it-all-started-with-toi/articleshow/98598870.cms?from=mdr" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
                </div>
              </div>
            </div>
            
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="300"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-3.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p> October 13, 2021</p>
                  </div>
                  <h4 class="mb-3">60 Seconds With Mangesh Ghogre </h4>
                  <p>A chat with one of the New York Times Crossword constructors.</p>
                  <p>
                      
                   Best gift you have ever been given, material or otherwise?</<p>
<p>I remember I gifted myself a huge Random House Webster’s dictionary when I was 17. I still have it. I think every word I studied in that dictionary has been like a brick in the wall of my life...
                  </p>
                </div>
                <a href="https://www.nytimes.com/2021/10/13/crosswords/puzzle-constructor-mangesh-ghogre.html" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
              </div>
              </div>
            </div>
            
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="400"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-4.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p>October 2, 2019</p>
                  </div>
                  <h4 class="mb-3">Gandhi at 150: Icon immortalised in special New York Times crossword, made by Indian</h4>
                  <p>
                   Investment banker Mangesh Ghogre went from a boy with limited vocabulary and no exposure to American culture to becoming the only Indian to have published crosswords in The New York Times—including a prestigious one to mark Gandhi's 150th birth anniversary on October 2, presented with a twist...</p>
                </div>
                <a href="https://www.forbesindia.com/article/special/gandhi-at-150-icon-immortalised-in-special-new-york-times-crossword-made-by-indian/55547/1" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
              </div>
              </div>
            </div> 
            
            
            
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="400"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-5.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p>MAY 16, 2018</p>
                  </div>
                  <h4 class="mb-3">This Boy From Mumbai Became the World’s Unlikeliest Crossword King</h4>
                  <p>
                   As a teenager, Mangesh Ghogre was obsessed with decoding puzzles filled with foreign references. Now he’s the only non-American to ever create them for The New York Times.</p>
                   <p>In a brightly lit room on the ground floor of the United States Consulate General building in Mumbai, India, Mangesh Ghogre...</p>
                </div>
                <a href="https://www.narratively.com/p/this-boy-from-mumbai-became-the-worlds-unlikeliest-crossword-king" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
              </div>
              </div>
            </div>
            
            
            <div
              class="col m-30px-b"
              data-aos="fade-up"
              data-aos-duration="1000"
              data-aos-delay="400"
            >
              <div class="card h-100 translateEffect1">
                  <img src="<?php echo base_url()?>assets/images/cw/cw-6.jpg">
                  
                  <div class="a-div">
                <div class="card-body">
                  <div class="date">
                    <p>March 16-18, 2012</p>
                  </div>
                  <h4 class="mb-3">Letter from Mangesh Ghogre [35th Annual ACPT, 2012]</h4>
                  <p>
                   A crossword enthusiast from India, Mangesh Ghogre, is coming to the ACPT this year as an official. It's his first trip ever to the U.S. And to my memory he's our first participant ever from India, as either a judge or a contestant. Below is a short piece he just wrote about crosswords and his forthcoming trip. –Will Shortz</p>
                   <p>For someone like me, who has come all the...</p>
                </div>
                <a href="https://www.crosswordtournament.com/2012/mangesh.htm" target="_blank" class="link"
                  >Read more<i class="icofont-rounded-right"></i
                ></a>
              </div>
              </div>
            </div>
            
            
          </div>
        </div>
      </section>
      <!-- ========== Events section end ========== -->
    <!-- ========== Footer section Start ========== -->
<?php include("footer.php"); ?>