<!DOCTYPE html>
<html class="loading" lang="en" data-textdirection="ltr">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0, minimal-ui">
    <meta name="description" content="Mangesh Ghogre | Crossword Admin Login">
    <meta name="keywords" content="Mangesh Ghogre | Crossword Admin Login">
    <meta name="author" content="Mangesh Ghogre | Crossword Admin Login">
    <title>Login</title>
    <link rel="apple-touch-icon" href="<?php echo base_url()?>assets/images/cw/favicon.png">
    <link rel="shortcut icon" type="image/x-icon" href="<?php echo base_url()?>assets/images/cw/favicon.png">
    <link href="https://fonts.googleapis.com/css?family=Muli:300,300i,400,400i,600,600i,700,700i%7CComfortaa:300,400,700" rel="stylesheet">

    <!-- BEGIN: Vendor CSS-->
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/vendors/css/vendors.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/vendors/css/forms/toggle/switchery.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/plugins/forms/switch.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/core/colors/palette-switch.min.css">
    <!-- END: Vendor CSS-->

    <!-- BEGIN: Theme CSS-->
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/bootstrap-extended.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/colors.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/components.min.css">
    <!-- END: Theme CSS-->

    <!-- BEGIN: Page CSS-->
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/core/menu/menu-types/vertical-menu.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/core/colors/palette-gradient.min.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/pages/login-register.min.css">
    <!-- END: Page CSS-->

    <!-- BEGIN: Custom CSS-->
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/style.css">
    <link rel="stylesheet" type="text/css" href="<?php echo base_url()?>app-assets/css/custom.css">
    <!-- END: Custom CSS-->

  </head>
  <!-- END: Head-->

  <!-- BEGIN: Body-->
  <body class="vertical-layout vertical-menu 1-column  bg-full-screen-image blank-page blank-page" data-open="click" data-menu="vertical-menu" data-color="bg-gradient-x-purple-blue" data-col="1-column">
    <!-- BEGIN: Content-->
    <div class="app-content content">
      <div class="content-wrapper">
        <div class="content-wrapper-before"></div>
        <div class="content-header row">
        </div>
        <div class="content-body"><section class="flexbox-container">
    <div class="col-12 d-flex align-items-center justify-content-center">
        <div class="col-lg-4 col-md-6 col-10 box-shadow-2 p-0">
            <div class="card border-grey border-lighten-3 px-1 py-1 m-0">
                <div class="card-header border-0">
                    <div class="text-center mb-1">
                            <img src="<?php echo base_url()?>assets/images/cw/favicon.png" alt="branding logo" style="width: 70px;">
                    </div>
                    <div class="font-large-1  text-center">                       
                        Admin Login
                    </div>
                </div>
                <div class="card-content">
                   
                    <div class="card-body" id="main_arena">
                        <?php
                            if ($msg) {
                                echo '<div class="n_ok"><p>';
                                echo $msg;
                                echo '</p></div>';
                            }
                            
                            if($this->session->flashdata($this->config->item('msg_key'))) {
                                echo $this->session->flashdata($this->config->item('msg_key'));
                            }
                        ?>
                        <?php
                            echo form_open($this->uri->uri_string());
                            if (validation_errors()) {
                                echo '<div class="n_error">';
                                echo validation_errors();
                                echo '</div><div class="sep"></div>';
                            }
                            if (isset($errors) && strlen($errors)) {
                                echo '<div class="n_error">';
                                echo $errors;
                                echo '</div><div class="sep"></div>';
                            }
                        ?>
                       
                            <fieldset class="form-group position-relative has-icon-left">
                                <input type="text" class="form-control round" id="username" name="username" placeholder="Your Username" required>

                                <div class="form-control-position">
                                    <i class="fa-solid fa-user"></i>
                                </div>
                            </fieldset>
                            <fieldset class="form-group position-relative has-icon-left">
                                <input type="password" class="form-control round" id="password" name="password" placeholder="Enter Password" required>
                                
                                <div class="form-control-position">
                                    <i class="fa-solid fa-lock"></i>
                                </div>
                            </fieldset>
                                                      
                            <div class="form-group text-center">
                                <!-- <button type="submit" name="login" class="btn round btn-block btn-glow btn-bg-gradient-x-purple-blue col-12 mr-1 mb-1">Login</button>     -->
                                <input type="submit" name="login" id="login" value="Login"/ class="btn round btn-block btn-glow btn-bg-gradient-x-purple-blue col-12 mr-1 mb-1">
                            </div>
                           <?php
                        echo form_close();
                        ?>
                        
                    </div>
                                        
                </div>
            </div>
        </div>
    </div>
</section>

        </div>
      </div>
    </div>
    <!-- END: Content-->


    <!-- BEGIN: Vendor JS-->
    <script src="<?php echo base_url()?>app-assets/vendors/js/vendors.min.js" type="text/javascript"></script>
    <script src="<?php echo base_url()?>app-assets/vendors/js/forms/toggle/switchery.min.js" type="text/javascript"></script>
    <script src="<?php echo base_url()?>app-assets/js/scripts/forms/switch.min.js" type="text/javascript"></script>
    <!-- BEGIN Vendor JS-->

    <!-- BEGIN: Page Vendor JS-->
    <script src="<?php echo base_url()?>app-assets/vendors/js/forms/validation/jqBootstrapValidation.js" type="text/javascript"></script>
    <!-- END: Page Vendor JS-->

    <!-- BEGIN: Theme JS-->
    <script src="<?php echo base_url()?>app-assets/js/core/app-menu.min.js" type="text/javascript"></script>
    <script src="<?php echo base_url()?>app-assets/js/core/app.min.js" type="text/javascript"></script>
    <!-- END: Theme JS-->

    <!-- BEGIN: Page JS-->
    <script src="<?php echo base_url()?>app-assets/js/scripts/forms/form-login-register.min.js" type="text/javascript"></script>
    <!-- END: Page JS-->

  </body>
  <!-- END: Body-->

</html>